unit U_AGS_script_functions;

// you can use this unit to call AGS script functions

interface

uses U_AGS_Interface;

var
  // character functions
  AnimateCharacter:                    procedure (CHARID, loop, speed, repeat_: int); cdecl = nil;
  AnimateCharacterEx:                  procedure (CHARID, loop, speed, repeat_, direction, blocking: int); cdecl = nil;
  AreCharactersColliding:              function (CHARID1, CHARID2: int): int; cdecl = nil;
  AreCharObjColliding:                 function (CHARID, obj: int): int; cdecl = nil;
  ChangeCharacterView:                 procedure (CHARID, newview: int); cdecl = nil;
  FaceCharacter:                       procedure (CHARID, tofaceid: int); cdecl = nil;
  FaceLocation:                        procedure (CHARID, x, y: int); cdecl = nil;
  FollowCharacter:                     procedure (CHARID, chartofollow: int); cdecl = nil;
  FollowCharacterEx:                   procedure (CHARID, chartofollow, dist, eagerness: int); cdecl = nil;
  GetCharacterAt:                      function (x, y: int): int; cdecl = nil;
  GetPlayerCharacter:                  function: int; cdecl = nil;
  MoveCharacter:                       procedure (CHARID, x, y: int); cdecl = nil;
  MoveCharacterBlocking:               procedure (CHARID, x, y, direct: int); cdecl = nil;
  MoveCharacterDirect:                 procedure (CHARID, x, y: int); cdecl = nil;
  MoveCharacterPath:                   procedure (CHARID, x, y: int); cdecl = nil;
  MoveCharacterStraight:               procedure (CHARID, x, y: int); cdecl = nil;
  MoveCharacterToHotspot:              procedure (CHARID, hotspot: int); cdecl = nil;
  MoveCharacterToObject:               procedure (CHARID, object_: int); cdecl = nil;
  ReleaseCharacterView:                procedure (CHARID: int); cdecl = nil;
  RunCharacterInteraction:             procedure (CHARID, mode: int); cdecl = nil;
  SetCharacterBaseline:                procedure (CHARID, baseline: int); cdecl = nil;
  SetCharacterClickable:               procedure (CHARID, is_clickable: int); cdecl = nil;
  SetCharacterIdle:                    procedure (CHARID, idleview, delay: int); cdecl = nil;
  SetCharacterIgnoreLight:             procedure (CHARID, ignore: int); cdecl = nil;
  SetCharacterIgnoreWalkbehinds:       procedure (CHARID, ignore: int); cdecl = nil;
  SetCharacterProperty:                procedure (CHARID, PROPERTY_, new_value: int); cdecl = nil;
  SetCharacterSpeechView:              procedure (CHARID, view: int); cdecl = nil;
  SetCharacterSpeed:                   procedure (CHARID, newspeed: int); cdecl = nil;
  SetCharacterTransparency:            procedure (CHARID, amount: int); cdecl = nil;
  SetCharacterView:                    procedure (CHARID, view: int); cdecl = nil;
  SetCharacterViewEx:                  procedure (CHARID, view, loop, align: int); cdecl = nil;
  SetPlayerCharacter:                  procedure (char_id: int); cdecl = nil;
  SetTalkingColor:                     procedure (CHARID, newcolor: int); cdecl = nil;
  StopMoving:                          procedure (CHARID: int); cdecl = nil;

  // File I/O functions (better use delphi file i/o methods)

  // Game / Global functions

  // GUI functions

  // Hotspot functions
  DisableHotspot:                      procedure (hsnum: int); cdecl = nil;
  EnableHotspot:                       procedure (hsnum: int); cdecl = nil;
  GetHotspotAt:                        function (x, y: int): int; cdecl = nil;
  GetHotspotPointX:                    function (hotspot: int): int; cdecl = nil;
  GetHotspotPointY:                    function (hotspot: int): int; cdecl = nil;
  RunHotspotInteraction:               procedure (hotspot, mode: int); cdecl = nil;

  // Inventory functions
  AddInventory:                        procedure (what: int); cdecl = nil;
  GetInvAt:                            function (x, y: int): int; cdecl = nil;
  GetInvName:                          procedure (item: int; const buffer: PChar); cdecl = nil;
  InventoryScreen:                     procedure; cdecl = nil;
  IsInventoryInteractionAvailable:     function (item, mode: int): int; cdecl = nil;
  LoseInventory:                       procedure (what: int); cdecl = nil;
  RunInventoryInteraction:             procedure (item, mode: int); cdecl = nil;
  SetActiveInventory:                  procedure (inv_item: int); cdecl = nil;
  SetInvDimensions:                    procedure (width, height: int); cdecl = nil;
  SetInvItemPic:                       procedure (inv, sprite_slot: int); cdecl = nil;
  UpdateInventory:                     procedure; cdecl = nil;

  // Mouse functions

  // Multimedia functions
  CDAudio:                             procedure (command, param: int); cdecl = nil;
  GetCurrentMusic:                     function: int; cdecl = nil;
  GetMIDIPosition:                     function: int; cdecl = nil;
  GetMP3PosMillis:                     function: int; cdecl = nil;
  IsChannelPlaying:                    function (channel: int): int; cdecl = nil;
  IsMusicPlaying:                      function: int; cdecl = nil;
  IsMusicVoxAvailable:                 function: int; cdecl = nil;
  IsSoundPlaying:                      function: int; cdecl = nil;
  IsSpeechVoxAvailable:                function: int; cdecl = nil;
  PlayAmbientSound:                    procedure (channel, sound, volume, x, y: int); cdecl = nil;
  PlayFlic:                            procedure (flic_number, options: int); cdecl = nil;
  PlayMP3File:                         procedure (const filename: PChar); cdecl = nil;
  PlayMusic:                           procedure (music_number: int); cdecl = nil;
  PlaySilentMIDI:                      procedure (music_number: int); cdecl = nil;
  PlaySound:                           procedure (sound_number: int); cdecl = nil;
  PlaySoundEx:                         procedure (sound_number, channel: int); cdecl = nil;
  PlayVideo:                           procedure (const filename: string; skip, flags: int); cdecl = nil;
  SeekMIDIPosition:                    procedure (position: int); cdecl = nil;
  SeekMODPattern:                      procedure (pattern: int); cdecl = nil;
  SeekMP3PosMillis:                    procedure (position: int); cdecl = nil;
  SetChannelVolume:                    procedure (channel, volume: int); cdecl = nil;
  SetDigitalMasterVolume:              procedure (volume: int); cdecl = nil;
  SetFrameSound:                       procedure (view, loop, frame, sound: int); cdecl = nil;
  SetMusicMasterVolume:                procedure (volume: int); cdecl = nil;
  SetMusicRepeat:                      procedure (loopflag: int); cdecl = nil;
  SetMusicVolume:                      procedure (volume: int); cdecl = nil;
  SetSoundVolume:                      procedure (volume: int); cdecl = nil;
  SetSpeechVolume:                     procedure (volume: int); cdecl = nil;
  SetVoiceMode:                        procedure (new_mode: int); cdecl = nil;
  StopAmbientSound:                    procedure (channel: int); cdecl = nil;
  StopChannel:                         procedure (channel: int); cdecl = nil;
  StopMusic:                           procedure; cdecl = nil;

  // Object functions
  // Overlay functions
  // Palette functions
  // Parser functions
  // Region functions
  DisableRegion:                       procedure (regnum: int); cdecl = nil;
  EnableRegion:                        procedure (regnum: int); cdecl = nil;
  GetRegionAt:                         function (x, y: int): int; cdecl = nil;
  RunRegionInteraction:                procedure (region, event: int); cdecl = nil;
  SetAreaLightLevel:                   procedure (area, level: int); cdecl = nil;

  // Room / Screen functions
  FadeIn:                              procedure (speed: int); cdecl = nil;
  FadeOut:                             procedure (speed: int); cdecl = nil;
  FlipScreen:                          procedure (way: int); cdecl = nil;
  GetBackgroundFrame:                  function: int; cdecl = nil;
  GetViewportX:                        function: int; cdecl = nil;
  GetViewportY:                        function: int; cdecl = nil;
  GetWalkableAreaAt:                   function (x, y: int): int; cdecl = nil;
  MoveToWalkableArea:                  procedure (CHARID: int); cdecl = nil;
  NewRoom:                             procedure (room_number: int); cdecl = nil;
  NewRoomEx:                           procedure (room_number, x, y: int); cdecl = nil;
  RawClearScreen:                      procedure (colour: int); cdecl = nil;
  RawDrawCircle:                       procedure (x, y, radius: int); cdecl = nil;
  RawDrawImage:                        procedure (x, y, slot: int); cdecl = nil;
  RawDrawLine:                         procedure (from_x, from_y, to_x, to_y: int); cdecl = nil;
  RawDrawTriangle:                     procedure (x1, y1, x2, y2, x3, y3: int); cdecl = nil;
  RawPrint:                            procedure (x, y: int; const text: PChar; const args: array of const); cdecl = nil;
  RawPrintMessageWrapped:              procedure (x, y, width, font, message_number: int); cdecl = nil;
  RawRestoreScreen:                    procedure; cdecl = nil;
  RawSaveScreen:                       procedure; cdecl = nil;
  RawSetColor:                         procedure (colour: int); cdecl = nil;
  ReleaseViewport:                     procedure; cdecl = nil;
  RemoveWalkableArea:                  procedure (areanum: int); cdecl = nil;
  ResetRoom:                           procedure (room_number: int); cdecl = nil;
  RestoreWalkableArea:                 procedure (areanum: int); cdecl = nil;
  SetBackgroundFrame:                  procedure (frame: int); cdecl = nil;
  SetScreenTransition:                 procedure (trans_type: int); cdecl = nil;
  SetViewport:                         procedure (x, y: int); cdecl = nil;
  SetWalkBehindBase:                   procedure (area, baseline: int); cdecl = nil;
  ShakeScreen:                         procedure (amount: int); cdecl = nil;
  ShakeScreenBackground:               procedure (delay, amount, length: int); cdecl = nil;
  TintScreen:                          procedure (red, green, blue: int); cdecl = nil;

  // String functions (better use delphi string methods)
  // Text display / Speech functions

function InitScriptFunctions (var Reason: string): Boolean;

implementation

function InitScriptFunctions (var Reason: string): Boolean;
const
     cSeparator = ', ';
var
   missingFunctions: string;

  procedure GetScriptFunctionAddress (const FuncName: string; var FuncAddress: Pointer);
  begin
       FuncAddress := AGS_Engine.GetScriptFunctionAddress (PChar (FuncName));
       if Assigned (FuncAddress) then Exit;
       Result := False;
       missingFunctions := missingFunctions + FuncName + cSeparator;
  end;

begin
     Result := True;
     SetLength (missingFunctions, 0);
     // character functions
     GetScriptFunctionAddress ('AnimateCharacter', @AnimateCharacter);
     GetScriptFunctionAddress ('AnimateCharacterEx', @AnimateCharacterEx);
     GetScriptFunctionAddress ('AreCharactersColliding', @AreCharactersColliding);
     GetScriptFunctionAddress ('AreCharObjColliding', @AreCharObjColliding);
     GetScriptFunctionAddress ('ChangeCharacterView', @ChangeCharacterView);
     GetScriptFunctionAddress ('FaceCharacter', @FaceCharacter);
     GetScriptFunctionAddress ('FaceLocation', @FaceLocation);
     GetScriptFunctionAddress ('FollowCharacter', @FollowCharacter);
     GetScriptFunctionAddress ('FollowCharacterEx', @FollowCharacterEx);
     GetScriptFunctionAddress ('GetCharacterAt', @GetCharacterAt);
     GetScriptFunctionAddress ('GetPlayerCharacter', @GetPlayerCharacter);
     GetScriptFunctionAddress ('MoveCharacter', @MoveCharacter);
     GetScriptFunctionAddress ('MoveCharacterBlocking', @MoveCharacterBlocking);
     GetScriptFunctionAddress ('MoveCharacterDirect', @MoveCharacterDirect);
     GetScriptFunctionAddress ('MoveCharacterPath', @MoveCharacterPath);
     GetScriptFunctionAddress ('MoveCharacterStraight', @MoveCharacterStraight);
     GetScriptFunctionAddress ('MoveCharacterToHotspot', @MoveCharacterToHotspot);
     GetScriptFunctionAddress ('MoveCharacterToObject', @MoveCharacterToObject);
     GetScriptFunctionAddress ('ReleaseCharacterView', @ReleaseCharacterView);
     GetScriptFunctionAddress ('RunCharacterInteraction', @RunCharacterInteraction);
     GetScriptFunctionAddress ('SetCharacterBaseline', @SetCharacterBaseline);
     GetScriptFunctionAddress ('SetCharacterClickable', @SetCharacterClickable);
     GetScriptFunctionAddress ('SetCharacterIdle', @SetCharacterIdle);
     GetScriptFunctionAddress ('SetCharacterIgnoreLight', @SetCharacterIgnoreLight);
     GetScriptFunctionAddress ('SetCharacterIgnoreWalkbehinds', @SetCharacterIgnoreWalkbehinds);
     GetScriptFunctionAddress ('SetCharacterProperty', @SetCharacterProperty);
     GetScriptFunctionAddress ('SetCharacterSpeechView', @SetCharacterSpeechView);
     GetScriptFunctionAddress ('SetCharacterSpeed', @SetCharacterSpeed);
     GetScriptFunctionAddress ('SetCharacterTransparency', @SetCharacterTransparency);
     GetScriptFunctionAddress ('SetCharacterView', @SetCharacterView);
     GetScriptFunctionAddress ('SetCharacterViewEx', @SetCharacterViewEx);
     GetScriptFunctionAddress ('SetPlayerCharacter', @SetPlayerCharacter);
     GetScriptFunctionAddress ('SetTalkingColor', @SetTalkingColor);
     GetScriptFunctionAddress ('StopMoving', @StopMoving);

     // File I/O functions (better use delphi file i/o methods)
     // Game / Global functions
     // GUI functions
     // Hotspot functions
     GetScriptFunctionAddress ('DisableHotspot', @DisableHotspot);
     GetScriptFunctionAddress ('EnableHotspot', @EnableHotspot);
     GetScriptFunctionAddress ('GetHotspotAt', @GetHotspotAt);
     GetScriptFunctionAddress ('GetHotspotPointX', @GetHotspotPointX);
     GetScriptFunctionAddress ('GetHotspotPointY', @GetHotspotPointY);
     GetScriptFunctionAddress ('RunHotspotInteraction', @RunHotspotInteraction);

     // Inventory functions
     GetScriptFunctionAddress ('AddInventory', @AddInventory);
     GetScriptFunctionAddress ('GetInvAt', @GetInvAt);
     GetScriptFunctionAddress ('GetInvName', @GetInvName);
     GetScriptFunctionAddress ('InventoryScreen', @InventoryScreen);
     GetScriptFunctionAddress ('IsInventoryInteractionAvailable', @IsInventoryInteractionAvailable);
     GetScriptFunctionAddress ('LoseInventory', @LoseInventory);
     GetScriptFunctionAddress ('RunInventoryInteraction', @RunInventoryInteraction);
     GetScriptFunctionAddress ('SetActiveInventory', @SetActiveInventory);
     GetScriptFunctionAddress ('SetInvDimensions', @SetInvDimensions);
     GetScriptFunctionAddress ('SetInvItemPic', @SetInvItemPic);
     GetScriptFunctionAddress ('UpdateInventory', @UpdateInventory);

     // Mouse functions

     // Multimedia functions
     GetScriptFunctionAddress ('CDAudio', @CDAudio);
     GetScriptFunctionAddress ('GetCurrentMusic', @GetCurrentMusic);
     GetScriptFunctionAddress ('GetMIDIPosition', @GetMIDIPosition);
     GetScriptFunctionAddress ('GetMP3PosMillis', @GetMP3PosMillis);
     GetScriptFunctionAddress ('IsChannelPlaying', @IsChannelPlaying);
     GetScriptFunctionAddress ('IsMusicPlaying', @IsMusicPlaying);
     GetScriptFunctionAddress ('IsMusicVoxAvailable', @IsMusicVoxAvailable);
     GetScriptFunctionAddress ('IsSoundPlaying', @IsSoundPlaying);
     GetScriptFunctionAddress ('IsVoxAvailable', @IsSpeechVoxAvailable); // IsSpeechVoxAvailable is alias for IsVoxAvailable
     GetScriptFunctionAddress ('PlayAmbientSound', @PlayAmbientSound);
     GetScriptFunctionAddress ('PlayFlic', @PlayFlic);
     GetScriptFunctionAddress ('PlayMP3File', @PlayMP3File);
     GetScriptFunctionAddress ('PlayMusic', @PlayMusic);
     GetScriptFunctionAddress ('PlaySilentMIDI', @PlaySilentMIDI);
     GetScriptFunctionAddress ('PlaySound', @PlaySound);
     GetScriptFunctionAddress ('PlaySoundEx', @PlaySoundEx);
     GetScriptFunctionAddress ('PlayVideo', @PlayVideo);
     GetScriptFunctionAddress ('SeekMIDIPosition', @SeekMIDIPosition);
     GetScriptFunctionAddress ('SeekMODPattern', @SeekMODPattern);
     GetScriptFunctionAddress ('SeekMP3PosMillis', @SeekMP3PosMillis);
     GetScriptFunctionAddress ('SetChannelVolume', @SetChannelVolume);
     GetScriptFunctionAddress ('SetDigitalMasterVolume', @SetDigitalMasterVolume);
     GetScriptFunctionAddress ('SetFrameSound', @SetFrameSound);
     GetScriptFunctionAddress ('SetMusicMasterVolume', @SetMusicMasterVolume);
     GetScriptFunctionAddress ('SetMusicRepeat', @SetMusicRepeat);
     GetScriptFunctionAddress ('SetMusicVolume', @SetMusicVolume);
     GetScriptFunctionAddress ('SetSoundVolume', @SetSoundVolume);
     GetScriptFunctionAddress ('SetSpeechVolume', @SetSpeechVolume);
     GetScriptFunctionAddress ('SetVoiceMode', @SetVoiceMode);
     GetScriptFunctionAddress ('StopAmbientSound', @StopAmbientSound);
     GetScriptFunctionAddress ('StopChannel', @StopChannel);
     GetScriptFunctionAddress ('StopMusic', @StopMusic);

     // Object functions
     // Overlay functions
     // Palette functions
     // Parser functions
     // Region functions
     GetScriptFunctionAddress ('DisableRegion', @DisableRegion);
     GetScriptFunctionAddress ('EnableRegion', @EnableRegion);
     GetScriptFunctionAddress ('GetRegionAt', @GetRegionAt);
     GetScriptFunctionAddress ('RunRegionInteraction', @RunRegionInteraction);
     GetScriptFunctionAddress ('SetAreaLightLevel', @SetAreaLightLevel);

     // Room / Screen functions
     GetScriptFunctionAddress ('FadeIn', @FadeIn);
     GetScriptFunctionAddress ('FadeOut', @FadeOut);
     GetScriptFunctionAddress ('FlipScreen', @FlipScreen);
     GetScriptFunctionAddress ('GetBackgroundFrame', @GetBackgroundFrame);
     GetScriptFunctionAddress ('GetViewportX', @GetViewportX);
     GetScriptFunctionAddress ('GetViewportY', @GetViewportY);
     GetScriptFunctionAddress ('GetWalkableAreaAt', @GetWalkableAreaAt);
     GetScriptFunctionAddress ('MoveToWalkableArea', @MoveToWalkableArea);
     GetScriptFunctionAddress ('NewRoom', @NewRoom);
     GetScriptFunctionAddress ('NewRoomEx', @NewRoomEx);
     GetScriptFunctionAddress ('RawClearScreen', @RawClearScreen);
     GetScriptFunctionAddress ('RawDrawCircle', @RawDrawCircle);
     GetScriptFunctionAddress ('RawDrawImage', @RawDrawImage);
     GetScriptFunctionAddress ('RawDrawLine', @RawDrawLine);
     GetScriptFunctionAddress ('RawDrawTriangle', @RawDrawTriangle);
     GetScriptFunctionAddress ('RawPrint', @RawPrint);
     GetScriptFunctionAddress ('RawPrintMessageWrapped', @RawPrintMessageWrapped);
     GetScriptFunctionAddress ('RawRestoreScreen', @RawRestoreScreen);
     GetScriptFunctionAddress ('RawSaveScreen', @RawSaveScreen);
     GetScriptFunctionAddress ('RawSetColor', @RawSetColor);
     GetScriptFunctionAddress ('ReleaseViewport', @ReleaseViewport);
     GetScriptFunctionAddress ('RemoveWalkableArea', @RemoveWalkableArea);
     GetScriptFunctionAddress ('ResetRoom', @ResetRoom);
     GetScriptFunctionAddress ('RestoreWalkableArea', @RestoreWalkableArea);
     GetScriptFunctionAddress ('SetBackgroundFrame', @SetBackgroundFrame);
     GetScriptFunctionAddress ('SetScreenTransition', @SetScreenTransition);
     GetScriptFunctionAddress ('SetViewport', @SetViewport);
     GetScriptFunctionAddress ('SetWalkBehindBase', @SetWalkBehindBase);
     GetScriptFunctionAddress ('ShakeScreen', @ShakeScreen);
     GetScriptFunctionAddress ('ShakeScreenBackground', @ShakeScreenBackground);
     GetScriptFunctionAddress ('TintScreen', @TintScreen);

     // String functions (better use delphi string methods)
     // Text display / Speech functions

     if Result then Exit;
     SetLength (missingFunctions, Length (missingFunctions) - Length (cSeparator));
     Reason := Reason + 'Missing functions: ' + missingFunctions;
end;

end.
